%global codename fuerte
%global shortname orocos_kinematics_dynamics

Name:		ros-%{codename}-orocos-kinematics-dynamics
Version:	0.2.3
Release:	1%{?dist}
Summary:	ROS Kinematics and Dynamics Library
License:	LGPLv2+
URL:		http://ros.org/wiki/orocos_kinematics_dynamics
Source0:	https://code.ros.org/svn/release/download/stacks/orocos_kinematics_dynamics/orocos_kinematics_dynamics-%{version}/orocos_kinematics_dynamics-%{version}.tar.bz2
Patch0:		ros-orocos-kinematics-dynamics-linkfix.patch
BuildRequires:	ros-%{codename}-ros-devel
BuildRequires:	cmake, python-yaml, eigen3-devel, cppunit-devel, sip-devel
BuildRequires:	python-devel, chrpath
Provides:	ros-%{shortname} = %{version}-%{release}
Provides:	ros-orocos-kinematics-dynamics = %{version}-%{release}

%description
Orocos project to supply RealTime usable kinematics and dynamics code,
it contains code for rigid body kinematics calculations and
representations for kinematic structures and their inverse and forward
kinematic solvers.

%package devel
Summary:	Development files for ROS orocos_kinematics_dynamics
Requires:	eigen3-devel, cppunit-devel, sip-devel, ros-%{codename}-ros-devel
Requires:	python-devel
Provides:	ros-%{shortname}-devel = %{version}-%{release}
Provides:	ros-dynamic-reconfigure-devel = %{version}-%{release}

%description devel
Development files for ROS orocos_kinematics_dynamics.

%prep
%setup -q -c
%patch0 -p1 -b .linkfix
# We have to do this so the cmake gunk can find itself. So idiotic.
mv %{shortname}-%{version} %{shortname}

%build
cd %{shortname}
source /etc/catkin/profile.d/10.ros.all
export ROS_PACKAGE_PATH="%{_builddir}/%{name}-%{version}:$ROS_PACKAGE_PATH"

# This is a bit of a hack, but it gets the job done.
mkdir -p orocos_kdl/install_dir/include
ln -s ../../src orocos_kdl/install_dir/include/kdl

for i in orocos_kdl python_orocos_kdl; do
  pushd $i
  mkdir build
  cd build
  %cmake -DSETUPTOOLS_DEB_LAYOUT=OFF ..
  # make %{?_smp_mflags}
  make
  popd
done

%install
cd %{shortname}
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}
cp -a stack.xml %{buildroot}%{_datadir}/ros-stacks/%{shortname}/

pushd orocos_kdl
cd build
make DESTDIR=%{buildroot} install
# ROS thinks this is the right name, so we'll use it here instead.
mv %{buildroot}%{_datadir}/orocos-kdl/ %{buildroot}%{_datadir}/ros-stacks/%{shortname}/orocos_kdl/
cd ..
cp -a manifest.xml %{buildroot}%{_datadir}/ros-stacks/%{shortname}/orocos_kdl/
popd

pushd python_orocos_kdl
mkdir -p %{buildroot}%{_datadir}/ros-stacks/%{shortname}/python_orocos_kdl/lib
mkdir -p %{buildroot}%{python_sitearch}
cp -a lib/PyKDL.so %{buildroot}%{python_sitearch}
ln -s %{python_sitearch}/PyKDL.so %{buildroot}%{_datadir}/ros-stacks/%{shortname}/python_orocos_kdl/lib/PyKDL.so
cp -a cmake *.dox *.xml %{buildroot}%{_datadir}/ros-stacks/%{shortname}/python_orocos_kdl/
popd

cp -a kdl %{buildroot}%{_datadir}/ros-stacks/%{shortname}/

mkdir -p %{buildroot}%{_libdir}/pkgconfig/
mv %{buildroot}/usr/lib/*.so* %{buildroot}%{_libdir}

mv %{buildroot}/usr/lib/pkgconfig/orocos-kdl.pc %{buildroot}%{_libdir}/pkgconfig/orocos-kdl.pc
sed -i 's|${prefix}/lib|${prefix}/%{_lib}|g' %{buildroot}%{_libdir}/pkgconfig/orocos-kdl.pc

# Die, rpath, die.
chrpath -d %{buildroot}%{python_sitearch}/PyKDL.so

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%doc %{shortname}/orocos_kdl/COPYING %{shortname}/orocos_kdl/README
%{_datadir}/ros-stacks/%{shortname}/
%{_libdir}/liborocos-kdl.so.*
%{python_sitearch}/PyKDL.so

%files devel
%{_includedir}/kdl/
%{_libdir}/pkgconfig/orocos-kdl.pc
%{_libdir}/liborocos-kdl.so

%changelog
* Tue May 22 2012 Tom Callaway <spot@fedoraproject.org> - 0.2.3-1
- initial package
